////===============================================================================================
//// ļ, ȫú 
////===============================================================================================
// PWM024 ϱ,1ʱMOSͨ,  PWM135 ±, 0ʱMOSͨ
// PA0_HA, PA1_HB, PA2_HC,   60Hall(HCźǷ)

#include  "M451Series.h"

uint32_t ShutDown_AllMOS = 0x002A ;              // PWM0240,PWM1351,ض·MOS
uint32_t const Dead_Time = 115 ;                 // ʱ: 115+1 PWM CLK, Լ1.6us

//=================================================================================================
void Timer1_Init(void)
{
  TIMER1->CTL = TIMER_CTL_OPMODE_Msk                       // , 0xFFFFFF = 16.777215s 
              | TIMER_CTL_RSTCNT_Msk + 21 ;                // λ, 21+1 Ƶ,  1MHz 
  TIMER1->CTL |= TIMER_CTL_CNTEN_Msk ;                     // Timer1
  NVIC_SetPriority(TMR1_IRQn, 2) ;                         // жȼ 2
  NVIC_EnableIRQ(TMR1_IRQn) ;	                           // ʹж
}
void Delayus(uint32_t Tim)                                 // ܳ16 
{
  uint32_t Tick = TIMER1->CNT ;                            // Timer1֮ſԵ
  while(((TIMER1->CNT - Tick)&0xFFFFFF) <= Tim) ;
}
void HCLK_Switch_to_PLL(void)                              // PLLȶ,ؾõ
{
  CLK->CLKDIV0 = CLK_CLKDIV0_HCLK(2) ;                     // HCLK Ƶ,  72.39M
  while((CLK->STATUS & CLK_STATUS_PLLSTB_Msk) == 0) ;      //  PLL ȶ
  CLK->CLKSEL0 = CLK_CLKSEL0_PCLK1SEL_HCLK 
               | CLK_CLKSEL0_PCLK0SEL_HCLK
               | CLK_CLKSEL0_STCLKSEL_HCLK_DIV2 
               | CLK_CLKSEL0_HCLKSEL_PLL ;              
  CLK->PWRCTL  = CLK_PWRCTL_HIRCEN_Msk ;                   //ֻHIRC,HXTѡPLLʱԴʱز
  
}
void UART0_Init(uint32_t Baud)
{
  UART0->FUNCSEL = 0  ;                                    //UART ģʽ
  UART0->LINE    = UART_STOP_BIT_2
                 | UART_PARITY_NONE
                 | UART_WORD_LEN_8 ;                               
  UART0->BAUD    = UART_BAUD_BAUDM1_Msk | UART_BAUD_BAUDM0_Msk
                 + 22118400/Baud - 2 ;                           //UART ʱ 22M
  UART0->FIFO    = UART_FIFO_RFITL_8BYTES
                 | UART_FIFO_RTSTRGLV_8BYTES ;                            
  UART0->INTEN   = 0 ;                                   
}
void PWM024_Out_0_MOS_On(void)   
{
  PWM0->POLCTL    ^= 0x0015 ;                              // PWM024 
  ShutDown_AllMOS ^= 0x0015 ;    
  PWM0->BRKCTL0_1 ^= 0x10000 ;                             // PWM0 Brake ֵ
  PWM0->BRKCTL2_3 ^= 0x10000 ;                             // PWM2 
  PWM0->BRKCTL4_5 ^= 0x10000 ;                             // PWM4 
}
void PWM135_Out_1_MOS_On(void)
{
  PWM0->POLCTL    ^= 0x002A ;                              // PWM135 
  ShutDown_AllMOS ^= 0x002A ;      
  PWM0->BRKCTL0_1 ^= 0x40000 ;                             // PWM1 Brake ֵ
  PWM0->BRKCTL2_3 ^= 0x40000 ;                             // PWM3 
  PWM0->BRKCTL4_5 ^= 0x40000 ;                             // PWM5 
}

////==== Ķ, ɰ PWM  ======================================================
// PWM ʱ 36MHz, PWM CLK ʱ1/36 = 0.027us
// Ķ뷽ʽ, ڼĴ PWM0->PERIOD0 = Period ʱ, 0 ӵ Period-1 Ϊϼʱ
//  Period С 1 Ϊ¼ʱ, ʱΪ Period*2

// : 
// 0 ¼: Ƶ0(1ǰ)ʱ,0,ȼϵ, CMPDAT0=0ʱ,
// ϼʱ,Ƶ CMPDAT0, 1.¼ʱ,Ƶ CMPDAT1, ر0.
// :  CMPDAT0 ֵ >= Period ϼʱ(0 ~ Period)ߵĹ
//        CMPDAT1 ֵΪ0, Period,¼ʱ(Period ~ 1)0
//  ע:ֻҪ CMPDAT0 = PERIOD Ͳ, ȫ(0)

// CMPDAT1ȡֵΧӦΪ1~PERIOD,0¼ʹȡֵΧչΪ0~Period,¼ʱCMPDAT1͵ƽ
// CMPDAT0ȡֵΧӦΪ0~PERIOD-1,CMPDAT1=Periodʱ,CMPDAT0ȡֵPeriod,ʱȫ0

// : 
// ԳƲʱ: ֤ CMPDAT0+1  CMPDAT1 ȵ, ȡֵΧΪ 0 ~ Period
//                 0ƽʱ: CMPDAT0 + CMPDAT1, Χ 0(ȫ) ~ Period*2(ȫ) 
//                 ߶ڵ Period ʱ, ȫ
// ǶԳƲ: CMPDAT0>CMPDAT1ʱ,CMPDAT0ȡֵΧ0~Period-1,ǰ޸ȫ
//                 CMPDAT0<CMPDAT1ʱ,CMPDAT1ȡֵΧ0~Period,ȫ

void PWM0_Init(void)                       
{                                   
  PWM0->CTL0 = 0x10000000 | 0x20000000 ;   //Ա,ͣԭֵ,ĩ¿ռ                                                        
  PWM0->CTL1 = 0x07000000 | 0x00000AAA ;                   // PWM543210ģʽ,¼                                     
                                                     
  PWM0->CLKSRC    = 0 ;                                    // PWM ʱ = PCLK0 = 72M
  PWM0->CLKPSC0_1 = 0 ;  PWM0->CLKPSC2_3 = 0 ;  PWM0->CLKPSC4_5 = 0 ;   // Ƶ 
  
  PWM0->DTCTL0_1  = 0x10000 + Dead_Time ;                    
  PWM0->DTCTL2_3  = 0x10000 + Dead_Time ;                  // ʹ+ʱ(дλ)
  PWM0->DTCTL4_5  = 0x10000 + Dead_Time ; 
  PWM0->SSCTL     = 0x003F ;                               // PWM0_543210ͬʹλ
  
  PWM0->WGCTL0    = 0x00000555 ;                           // е㲻,0
  PWM0->WGCTL1    = 0x04440222 ;                           //CMPDAT024ر1, CMPDAT135ر0
  
  PWM0->PHS0_1 = 0 ; PWM0->PHS2_3 = 0 ; PWM0->PHS4_5 = 0 ; 
  PWM0->SWSYNC = 0 ; PWM0->SYNC   = 0 ;                    // λͬ
  
  PWM0->BRKCTL0_1= 0 ;                                     // Brakeδ
  PWM0->BRKCTL2_3= 0 ;
  PWM0->BRKCTL4_5= 0 ; 
  PWM0->POLCTL   = 0x002A ;                                // PWM135 
  PWM0->POEN     = 0x003F ;                                // ʹ, 6bit

//  PWM024_Out_0_MOS_On() ;                           
//  PWM135_Out_1_MOS_On() ;    
  PWM0->MSK      = ShutDown_AllMOS ;                 
  PWM0->MSKEN    = 0x003F ;                                //ʹ MASK , ȹض

  NVIC_SetPriority(PWM0P0_IRQn, 2) ;                       //Interrupt priority = 2 
  NVIC_EnableIRQ(PWM0P0_IRQn) ;						           
}
void PWM0_Set_Period(uint32_t PWM_Period) 
{
  PWM0->PERIOD0   = PWM_Period ;                           // PWM 
  PWM0->PERIOD2   = PWM_Period ;               
  PWM0->PERIOD4   = PWM_Period ;                           //PWMƵ36M/1000/2=18KHz 
}

//// PLLʹADC,ȶ ================================================================
//  config0 ϵHIRCHXT, 
void SystemInit(void)                                
{
  SYS_UnlockReg();
#if 1                                                      // HIRC                                         
  CLK->PWRCTL |= CLK_PWRCTL_HIRCEN_Msk ;                   
  while((CLK->STATUS & CLK_STATUS_HIRCSTB_Msk) == 0) ;     //  HIRC ȶ
  CLK->PLLCTL = CLK_PLLCTL_PLLSRC_HIRC                     
              | CLK_PLLCTL_NR(11) | CLK_PLLCTL_NF(144)
              | CLK_PLLCTL_NO_2 ;                          // 22M/11*144/2 = 144.77M
#else                                                      
  SYS->GPF_MFPL = SYS->GPF_MFPL & ~(SYS_GPF_MFPL_PF4MFP_Msk | SYS_GPF_MFPL_PF3MFP_Msk)
                | (SYS_GPF_MFPL_PF4MFP_XT1_IN 
                | SYS_GPF_MFPL_PF3MFP_XT1_OUT) ;           // configure GPF34 as crystal pin            
  CLK->PWRCTL  |= CLK_PWRCTL_HXT_EN ;                     
  while((CLK->STATUS & CLK_STATUS_HXTSTB_Msk) == 0) ;    
  CLK->PLLCTL = CLK_PLLCTL_PLLSRC_HXT                      
              | CLK_PLLCTL_NR(3) | CLK_PLLCTL_NF(72)
              | CLK_PLLCTL_NO_2  ;                         // 12M/3*72/2 = 144M
#endif  
  CLK->CLKSEL1 = CLK_CLKSEL1_UARTSEL_HIRC                  // UART_22.1184M
               | CLK_CLKSEL1_TMR0SEL_PCLK0                 // T0_72M,PWM0Ƶһ±ڼ
               | CLK_CLKSEL1_TMR1SEL_HIRC ;                // T1_22M
  CLK->CLKSEL2 = CLK_CLKSEL2_PWM0SEL_PCLK0 ;               // PWM0_72M
  CLK->APBCLK0 = CLK_APBCLK0_EADCCKEN_Msk          
               | CLK_APBCLK0_UART0CKEN_Msk                 // UART0, Ϣ
               | CLK_APBCLK0_TMR1CKEN_Msk 
               | CLK_APBCLK0_TMR0CKEN_Msk ;              
 
  CLK->APBCLK1 = CLK_APBCLK1_PWM0CKEN_Msk ;                          
  
  EADC->CTL = EADC_CTL_ADRST_Msk                           // ADC·λ,ӲԶ
            | EADC_CTL_ADCEN_Msk ;                         // Enable EADC
            
  SysTick->VAL  = 10*36000 ;            
  SysTick->LOAD = 10*36000 ;                               // 10 ms
  SCB->SHP[11]  = ~0 ;                                     // Interrupt priority = 3 
  SysTick->CTRL = SysTick_CTRL_CLKSOURCE_Msk
                | SysTick_CTRL_TICKINT_Msk 
                | SysTick_CTRL_ENABLE_Msk ;                            
}
