////===============================================================================================
//  Clock, GPIO, Timer1, UART0, PWM0 
// Clockó 22M Ƶ 72M, XT_12M  72M ĴҲд,PCLK  HCLK ĶƵ
// Timer1  1MHz, ں Delayus() ΢ʱ.
// PWM0_PC012345, NuEdu:PIN44~48,PIN50, Ҳ,  ӵ, Hall Ҳת
// PA012  Hall_ABC, GPIO ж Hall Ƕ,
// UART0  Tx  PD1, NuEdu ϵ PIN15, ᲻ַͣ: UART0 OK !
////===============================================================================================
#include  "M451Series.h"
#include  "IP_Initial_fun.h"
#include  "Interrupt_fun.h"

uint32_t Led_Flash       = 0x555555 ;                      // ֻõ24λ

uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt) ;

// LQFP48, 42 GPIO,ֵDOUT, ䷽MODE, 书MFP, GPIOȷֵ ////////////
void GPIO_Init(void)                           
{                                                // PA 8
  PA->DOUT      = 0xFFFF ;                          
  PA->MODE      = 0x0000003F ;                             // PA.012׼˫,Hall
  SYS->GPA_MFPL = 0x00000000 ;                           
                                                 // PB 9 
  PB->DOUT      = 0xFFFF ;                                
  PB->MODE      = 0 ;                           
  SYS->GPB_MFPL = 0 ;                           
  SYS->GPB_MFPH = 0 ;                           
                                                 // PC 8 
  PC->DOUT      = ShutDown_AllMOS ; 
  PC->MODE      = 0x0555 ;                                 // PWM0·, Ϊ 
  SYS->GPC_MFPL = SYS_GPC_MFPL_PC0MFP_PWM0_CH0 
                | SYS_GPC_MFPL_PC1MFP_PWM0_CH1 
                | SYS_GPC_MFPL_PC2MFP_PWM0_CH2
                | SYS_GPC_MFPL_PC3MFP_PWM0_CH3 
                | SYS_GPC_MFPL_PC4MFP_PWM0_CH4
                | SYS_GPC_MFPL_PC5MFP_PWM0_CH5 ; 
                                                 // PD 8 
  PD->DOUT      = 0xFFFF ;                                
  PD->MODE      = 0x00000400 ;               
  SYS->GPD_MFPL = SYS_GPD_MFPL_PD0MFP_UART0_RXD
                | SYS_GPD_MFPL_PD1MFP_UART0_TXD  ;                           
                                                 // PE 5 
  PB->DOUT      = 0xFFFF ;                                
  PB->MODE      = 0 ;                           
  SYS->GPB_MFPL = 0 ;                           
                                                 // PF 4,PF34_HXT, PF56_ICE 
  PB->DOUT      = 0xFFFF ;                                
  PB->MODE      = 0 ;                           
  SYS->GPB_MFPL = 0 ;                           

  PA->DBEN    = 0x0007 ;                                   // PA012 ʹȥ
  GPIO->DBCTL = 0x0008 ;                                   // 256HCLKȥʱ (256/72 = 3us)
  PA->INTTYPE = 0 ;                                        // ж
  PA->INTSRC  = ~0 ;
  PA->INTEN   = 0x00070007 ;                               // PA012غ½ж
  NVIC_SetPriority(GPA_IRQn, 2);
  NVIC_EnableIRQ(GPA_IRQn) ;		
}

//=================================================================================================
//   main()
//=================================================================================================
int main(void)
{  
  Timer1_Init() ;                                          // ʹTimer1Delayus()ʱ
  PWM0_Init() ;
  PWM_One_Percent = 20 ;                                   // 20_18KHz, 
  PWM0_Set_Period(100*PWM_One_Percent) ;                   //  PWM  18KHz/55us           
  UART0_Init(115200) ;
  GPIO_Init() ;                                            // GPIOȷֵ,ض MOS
  HCLK_Switch_to_PLL() ;                                   // HCLK л PLL 
  SYS_LockReg() ;
  Tx0FillFiFo("\nUART0 OK!\n",11) ;                        // ֤ UART0
  
  GPA_IRQHandler() ;                                       // HallAngle óֵ
  AngleStep = 0x1F ;                                       // 8λС
  DutyCMR   = 20*PWM_One_Percent ;
  
  PWM0->INTSTS0 = ~0 ;                                     // жϱ־ PIF0     
  PWM0->INTEN0  = PWM_INTEN0_PIEN0_Msk ;                   // ʹ PIE0 ж  
  PWM0->CNTCLR  = 0x003F ;                                 // Clear counter
  PWM0->SSTRG   = PWM_SSTRG_CNTSEN_Msk ;                   // ͬ PWM
  PWM0->MSKEN   = 0 ;                                      //  MASK, ʼ PWM 
  
  Delayus(100000) ;  
  DutyCMR = 80*PWM_One_Percent ;
  
  while(1){    
    Delayus(500000) ;                                      // 0.5 
    PD->DOUT ^= 0x0020 ;                                   // һ
    Tx0FillFiFo("UART0 OK!\n",10);
  }
}

//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   pStr, ʣַַ
//          0   ,  ַ
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{
  if(Cnt){                                                       //ַҪ
    do{
      if( UART0->FIFOSTS & UART_FIFOSTS_TXFULL_Msk ) break ;     //FiFo˾˳ѭ        
      UART0->DAT = *pStr++ ;                                     //FiFoһַ
    }while(--Cnt) ;                                              //ֱ
  }
  if(Cnt) return  pStr ; 
  else    return  0    ;                               
}
////convert a integer into a string for printing /////////////////////////////////////////
//input : Number, 32bit integer
//       *pStr,  the last address saving character.  
//return: Sum of character converted.
const uint8_t Asc[10]="0123456789" ;
uint32_t HexToStr(uint32_t Number, uint8_t*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{
    temp32u = Number ;
    Number /= 10 ; 
    *pStr-- = Asc[temp32u - Number*10];
    ++Cnt ;
  }while(Number);
  return Cnt ;
}
